mod Ex06

incl Mtex

incl Mtexrc

incl Maux

loc rem 
  \para \bf  6. CVICENIE Z PREDMETU 1-AIN-625 UVOD DO MATEMATICKEJ LOGIKY PRE 
  PROGRAMATOROV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end utorok 26.10.2010 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-625-lpp/1011zs/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane primitivne 
  rekurzivnym funkciam (vnorena jednoducha rekurzia ). Zadanie sa sklada z 
  tychto suborov: 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuje definicie niektorych 
         funkcii a predikatov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
   \item \para Subor \it  msyntax.cl  \end obsahuje syntax systemu CL. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohy v tomto subore: 0 
   \item \para Pocet bodov za premiove ulohy v tomto subore: 2 
  \end
  \para Odovzdat do 8.11.2010 (pondelok) do 12:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end Downloadable lecture notes available through the 
         web page of the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [3]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/2 Tex2_appl_sigma1_sb
  Prefix(80,0,Subsup(Id(0,Ent('sigma'),0),75,Num('1',0),None),
         Fenced(Op('[',0),Infix(Arg(0),30,2,Op(',',0),Arg(1)),Op(']',0)))

appldisp/3 Tex3_appl_sigma2_sb
  Prefix(80,0,Subsup(Id(0,Ent('sigma'),0),75,Num('2',0),None),
         Fenced(Op('[',0),
                Infix(Arg(0),30,2,Op(',',0),Infix(Arg(1),30,2,Op(',',0),Arg(2))),
                Op(']',0)))

appldisp/4 Tex_f4_rec_sr_map1
  Prefix(90,2,Subsup(Underover(Id(0,'M',0),None,Op(Ent('Tilde'),0)),75,Arg(0),None),
         Fenced(Op('(',0),
                Infix(Arg(1),30,2,Op(',',0),Infix(Arg(2),30,2,Op(',',0),Arg(3))),
                Op(')',0)))

appldisp/4 Tex_f4_rec_sr_map
  Prefix(90,2,Subsup(Id(0,'M',0),75,Arg(0),None),
         Fenced(Op('(',0),
                Infix(Arg(1),30,2,Op(',',0),Infix(Arg(2),30,2,Op(',',0),Arg(3))),
                Op(')',0)))

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end See [1]. 

rem 
  \para \bf  Section. Nested Simple Recursion.  \end 

rem 
  \para \bf  Subsection. Nested Simple Recursion: Case \ft k = 2 \end and 
  \ft n = 1 \end.  \end 

theory Nested_simple_recursion

fun G 'Tex_f1_g'

fun/4 H1 'Tex_f4_h'

fun/2 Sb1 'Tex2_appl_sigma1_sb'

fun/3 Sb2 'Tex3_appl_sigma2_sb'

loc rem 
  \para \bf  Exercise. \it  (bonus 2 points)  \end  \end 
  \header* fun/2 F 'Tex_f2_f' \end Show that if \ft G(y) \end, 
  \ft H1(x,z1,z2,y) \end, \ft Sb1(x,y) \end and \ft Sb2(x,y,z1) \end are all 
  primitive recursive then so is \ft F(x,y) \end defined by 

fun/2 F 'Tex_f2_f'
  F(0,y) = G(y)
  F(x+1,y) = H1(x,F(x,Sb1(x,y)),F(x,Sb2(x,y,F(x,Sb1(x,y)))),y)

loc rem 
  \para \it  Hint.  \end \header* fun/2 Cvf 'Tex_f2_rec_cvf_f' \end Derive the 
  function as primitive recursive with the help of its course of values 
  function: 

fun/2 Cvf 'Tex_f2_rec_cvf_f'
  Cvf(0,y) = F(0,y),0,0
  Cvf(x+1,y) = F(x+1,y),Cvf(x,Sb1(x,y)),Cvf(x,Sb2(x,y,F(x,Sb1(x,y))))

loc rem 
  \para \it  Proof.  \end 

loc rem 
  \para \it  Full binary trees.  \end The function \ft Full(n) \end creates a 
  full binary tree of the depth \ft n \end. Show that the function is primitive 
  recursive. 

fun Full 
  Full(n) = Foo

loc rem 
  \para \it  Local node condition.  \end \header* fun/4 V  \end The application 
  \ft V(x,y,l,r) \end determines the correct value \ft F(x,y) \end from the 
  subtrees \ft l \end and \ft r \end of a partial computation tree 
  \ft z,l,r \end for \ft F(x,y) \end. Show that the function is primitive 
  recursive. 

fun/4 V 
  V(x,y,l,r) = Foo

loc rem 
  \para \it  Local update.  \end \header* fun/4 U  \end The 4-ary function 
  \ft U(t,i,x,y) \end updates the partial computation tree \ft t \end for 
  \ft F(x,y) \end at position \ft i \end by a correct value. The function has 
  the following basic properties 
  \eq* 
    i < Exp(2,x)-1 -> U((z,l,r),i,x,y) = z,U(l,i,x-1,Sb1(x-1,y)),r
  \end
  \eq* 
    j < Exp(2,x)-1 -> 
    U((z,l,r),Exp(2,x)-1+j,x,y) = z,l,U(r,j,x-1,Sb2(x-1,y,Proj1(l)))
  \end
  \eq* 
    U((z,l,r),Exp(2,x+1)-2,x,y) = V(x,y,l,r),l,r
  \end
  \para Show that the function is primitive recursive. 

fun/4 U 
  U(t,i,x,y) = Foo

loc rem 
  \para \it  Global update.  \end \header* fun/4 Map 'Tex_f4_rec_sr_map' \end 
  The 4-ary function \ft Map(i,x,y,t) \end updates the partial computation tree 
  \ft t \end for \ft F(x,y) \end at each position \ft j < i \end by a correct 
  value. Show that the function is primitive recursive. 

fun/4 Map 'Tex_f4_rec_sr_map'
  Map(i,x,y,t) = Foo

loc rem 
  \para \it  Course of values function.  \end Show that the function 
  \ft Cvf(x,y) \end is primitive recursive. 

fun/2 Cvf_is_primrec 'Tex_f2_rec_cvf_f'
  Cvf_is_primrec(x,y) = Foo

loc rem 
  \para \it  Final step.  \end Show that the function \ft F(x,y) \end is 
  primitive recursive. 

fun/2 F_is_primrec 'Tex_f2_f'
  F_is_primrec(x,y) = Foo

end theory Nested_simple_recursion

rem 
  \para \bf  [CL] Remark.  \end You can test your solution by \it  interpreting 
   \end the theory. Choose \it  non-local  \end interpretation. 

rem 
  \para \bf  Theorem.  \end Primitive recursive functions are closed under 
  nested simple recursion for the case \ft k = 2 \end and \ft n = 1 \end. 

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

